//
// Created by philipp on 06.12.17.
//

#ifndef PROTOCOL_NETWORKING_H
#define PROTOCOL_NETWORKING_H

#include <boost/asio/io_service.hpp>
#include <thread>

namespace networking
{

class Networking
{
public:
    Networking()
    {
        work = std::make_unique<boost::asio::io_service::work>(ioService);
        thread = std::thread(
            [this]()
            { ioService.run(); });
    }

    ~Networking()
    {
        work.reset();
        ioService.stop();
        thread.join();
    }

    Networking(const Networking & other) = delete;

    Networking & operator=(const Networking & other) = delete;

    Networking(Networking && other) = delete;

    Networking & operator=(Networking && other) = delete;

    boost::asio::io_service & getIoService()
    { return ioService; }

private:
    boost::asio::io_service ioService;
    std::unique_ptr<boost::asio::io_service::work> work;
    std::thread thread;
};

}

#endif //PROTOCOL_NETWORKING_H
