//
// Created by philipp on 29.11.17.
//

#ifndef PROTOCOL_ENPOINTINFO_H
#define PROTOCOL_ENPOINTINFO_H

#include <string>
#include <boost/asio/ip/tcp.hpp>
#include "Protocol.h"

using boost::asio::ip::tcp;

namespace protocol
{
class VehicleEndpoint
{
public:
    VehicleEndpoint()
    {}

    VehicleEndpoint(VehicleId vehicleId, const std::string & host, std::uint16_t tcpPort, std::uint16_t udpPort)
        : vehicleId(vehicleId)
          , host(host)
          , tcpPort(tcpPort)
          , udpPort(udpPort)
    {}

    VehicleId getVehicleId() const
    { return vehicleId; }

    std::string getHost() const
    { return host; }

    std::uint16_t getTcpPort() const
    { return tcpPort; }

    std::uint16_t getUdpPort() const
    { return udpPort; }

    bool operator==(VehicleEndpoint & other)
    { return vehicleId == other.vehicleId; }

private:
    VehicleId vehicleId;
    std::string host;
    std::uint16_t tcpPort;
    std::uint16_t udpPort;
};
}

#endif //PROTOCOL_ENPOINTINFO_H
